package jp.hishidama.swing.popup;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;
import javax.swing.text.DefaultEditorKit;

/**
 * ftHg|bvAbvj[.
 * <p>
 * gpF
 * </p>
 *
 * <pre>
 * JTextField text = new JTextField();
 * new DefaultPopupMenu().installTo(text);
 *</pre>
 *
 * ɂAeLXgtB[hENbN邢̓ReLXgj[L[Ƀ|bvAbvj[\B
 * <ul>
 * <li>؂(<u>X</u>)</li>
 * <li>Rs[(<u>C</u>)</li>
 * <li>\t(<u>P</u>)</li>
 * <li>ׂđI(<u>A</u>)</li>
 * </ul>
 * ANVΏۃR|[lgɓo^ĂȂꍇ́Aj[͕\ȂB<br>
 * ႦJTreeł́uׂđIv͕\ȂB<br>
 * tɃRs[&amp;y[Xg͎ۂ͓삵Ȃꍇł蓖ĂĂ鎖̂ŁAقڏɕ\iIۂɓ삷Ƃ͌Ȃj
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JPopupMenu.html"
 *         >Ђ</a>
 * @since 2009.04.11
 * @version 2009.04.12
 */
public class DefaultPopupMenu extends AbstractAction implements MouseListener {
	private static final long serialVersionUID = -6253061612303005121L;

	/**
	 * ANV
	 */
	public static String DefaultPopupMenu_NAME = "context-menu";

	/**
	 * RXgN^[.
	 */
	public DefaultPopupMenu() {
		super(DefaultPopupMenu_NAME);
	}

	/**
	 * ݒ.
	 * <p>
	 * R|[lgɑ΂A|bvAbvJn}EXCxgL[Cxgo^B
	 * </p>
	 *
	 * @param c
	 *            |bvAbvj[Ώۂ̃R|[lg
	 */
	public void installTo(JComponent c) {
		c.removeMouseListener(this);
		c.addMouseListener(this);

		InputMap im = c.getInputMap();
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_CONTEXT_MENU, 0),
				DefaultPopupMenu_NAME);
		ActionMap am = c.getActionMap();
		am.put(DefaultPopupMenu_NAME, this);
	}

	/**
	 * ACXg[.
	 *
	 * @param c
	 *            ΏۃR|[lg
	 */
	public void uninstall(JComponent c) {
		c.removeMouseListener(this);
		InputMap im = c.getInputMap();
		im.remove(KeyStroke.getKeyStroke(KeyEvent.VK_CONTEXT_MENU, 0));
		ActionMap am = c.getActionMap();
		am.remove(DefaultPopupMenu_NAME);
	}

	/**
	 * ReLXgj[L[̏.
	 */
	@Override
	public void actionPerformed(ActionEvent e) {
		JComponent c = (JComponent) e.getSource();
		Point pos = c.getMousePosition();
		if (pos != null) {
			showPopup(c, pos.x, pos.y);
		}
	}

	// }EXCxg
	@Override
	public void mouseClicked(MouseEvent e) {
	}

	/**
	 * }EXL[̏.
	 */
	@Override
	public void mousePressed(MouseEvent e) {
		mousePopup(e);
	}

	/**
	 * }EX̃L[𗣂̏.
	 */
	@Override
	public void mouseReleased(MouseEvent e) {
		mousePopup(e);
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	protected void mousePopup(MouseEvent e) {
		if (!e.isPopupTrigger()) {
			return;
		}
		JComponent c = (JComponent) e.getSource();
		showPopup(c, e.getX(), e.getY());
		e.consume();
	}

	/**
	 * |bvAbvj[\.
	 * <p>
	 * }EX쓮ƃL[쓮ŋʁB
	 * </p>
	 *
	 * @param c
	 *            ΏۃR|[lg
	 * @param x
	 * @param y
	 */
	protected void showPopup(JComponent c, int x, int y) {
		JPopupMenu pmenu = new JPopupMenu();
		initPopupMenu(pmenu, c);
		pmenu.show(c, x, y);
	}

	protected void initPopupMenu(JPopupMenu pmenu, JComponent c) {
		ActionMap am = c.getActionMap();

		Action cut = am.get("cut");
		addMenu(pmenu, "؂(X)", cut, 'X', KeyStroke.getKeyStroke(
				KeyEvent.VK_X, KeyEvent.CTRL_DOWN_MASK));

		Action copy = am.get("copy");
		addMenu(pmenu, "Rs[(C)", copy, 'C', KeyStroke.getKeyStroke(
				KeyEvent.VK_C, KeyEvent.CTRL_DOWN_MASK));

		Action paste = am.get("paste");
		addMenu(pmenu, "\t(V)", paste, 'V', KeyStroke.getKeyStroke(
				KeyEvent.VK_V, KeyEvent.CTRL_DOWN_MASK));

		Action all = am.get(DefaultEditorKit.selectAllAction);
		addMenu(pmenu, "ׂđI(A)", all, 'A', KeyStroke.getKeyStroke(
				KeyEvent.VK_A, KeyEvent.CTRL_DOWN_MASK));
	}

	protected boolean addMenu(JPopupMenu menu, String text, Action action,
			int mnemonic, KeyStroke ks) {
		if (action != null) {
			JMenuItem mi = menu.add(new PopupMenuDelegateAction(action));
			if (text != null) {
				mi.setText(text);
			}
			if (mnemonic != 0) {
				mi.setMnemonic(mnemonic);
			}
			if (ks != null) {
				mi.setAccelerator(ks);
			}
			return true;
		}
		return false;
	}
}
